<?php
/**
 * This project has been generated by nuts generator
 * nuts has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 */


namespace Provider\General;


use Carbon\Carbon;
use Handler\DataValidationException;
use Provider\Response\Results;

class GeneralHandler
{
	public static function randomString($length)
	{
		$string = "abcdfghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ123456790" . sha1(Carbon::now());
		$randomString = substr(str_shuffle($string), 0, $length);
		return $randomString;
	}

	public static function validateBase64Image($imageBase)
	{
		return stripos($imageBase, "data:image");
	}

	public static function uploadImage($imageBase, $dir)
	{
		if (!file_exists(BASE_DIR . "/" . $dir)) {
			mkdir(BASE_DIR . "/" . $dir, 0777, true);
		}

		$strImage = $imageBase;
		list($type, $strImage) = explode(';', $strImage);
		list(, $extension) = explode('/', $type);
		list(, $strImage) = explode(',', $strImage);
		$fileName = md5(Carbon::now()) . '.' . $extension;
		$image = base64_decode($strImage);
		file_put_contents(BASE_DIR . "/$dir/" . $fileName, $image);
		$server_url = baseURL . "/public/$dir/" . $fileName;
		return $server_url;
	}


	public static function validatePaging($input)
	{
		$response = new Results();
		$validating = [];
		if (empty($input["pageSize"])) {
			array_push($validating, ["pageSize" => "FIELD_CANNOT_BE_NULL"]);
		}
		if (empty($input["page"])) {
			array_push($validating, ["page" => "FIELD_CANNOT_BE_NULL"]);
		}
		if (empty($input["order"])) {
			array_push($validating, ["order" => "FIELD_CANNOT_BE_NULL"]);
		}
		if (!empty($input["order"])) {
			if (empty($input["order"]["column"])) {
				array_push($validating, ["column" => "FIELD_CANNOT_BE_NULL"]);
			} else if (empty($input["order"]["direction"])) {
				array_push($validating, ["direction" => "FIELD_CANNOT_BE_NULL"]);
			}
		}
		if ($validating) {
			$data = [
				"meta" => [
					"timestamp" => (integer)microtime(true),
					"status" => json_decode(INVALID_PAGE_FORMAT),
					"data" => array_collapse($validating),
				]
			];
			header("Content-type:application/json");
            http_response_code(422);
			echo json_encode($data);
			die();

		}
	}

	public static function validateInputData($input)
	{
		$response = new Results();
		if (empty($input["data"])) {
			$data = [
				"meta" => [
					"timestamp" => (integer)microtime(true),
					"status" => json_decode(MISSING_BODY_DATA),
					"data" => null
				]
			];
			header("Content-type:application/json");
			echo json_encode($data);
			die();
		}
	}

	public static function compareFloatNumbers($float1, $float2, $operator = '=')
	{

		// Check numbers to 5 digits of precision
		$epsilon = 0.00001;

		$float1 = (float)$float1;
		$float2 = (float)$float2;

		switch ($operator) {
			// equal
			case "=":
			case "eq": {
				if (abs($float1 - $float2) < $epsilon) {
					return true;
				}
				break;
			}
			// less than
			case "<":
			case "lt": {
				if (abs($float1 - $float2) < $epsilon) {
					return false;
				} else {
					if ($float1 < $float2) {
						return true;
					}
				}
				break;
			}
			// less than or equal
			case "<=":
			case "lte": {
				if (self::compareFloatNumbers($float1, $float2, '<') || self::compareFloatNumbers($float1, $float2, '=')) {
					return true;
				}
				break;
			}
			// greater than
			case ">":
			case "gt": {
				if (abs($float1 - $float2) < $epsilon) {
					return false;
				} else {
					if ($float1 > $float2) {
						return true;
					}
				}
				break;
			}
			// greater than or equal
			case ">=":
			case "gte": {
				if (self::compareFloatNumbers($float1, $float2, '>') || self::compareFloatNumbers($float1, $float2, '=')) {
					return true;
				}
				break;
			}
			case "<>":
			case "!=":
			case "ne": {
				if (abs($float1 - $float2) > $epsilon) {
					return true;
				}
				break;
			}
			default: {
				die("Unknown operator '" . $operator . "' in compareFloatNumbers()");
			}
		}

		return false;

	}

	public static function reformatHourToDateTime($hour)
	{
		$newHour = explode(":", $hour);
		return Carbon::now()->setTime($newHour[0], $newHour[1], 0)->toDateTimeString();
	}

	public static function validateLocation($input)
	{
		if (empty($input["data"]["LocLngCustomer"])) {
			throw new DataValidationException(json_encode((["LocLngCustomer" => FIELD_CANNOT_BE_NULL])));
		}
		if (empty($input["data"]["LocLatCustomer"])) {
			throw new DataValidationException(json_encode((["LocLatCustomer" => FIELD_CANNOT_BE_NULL])));
		}
	}


}